/*
 * Created on Jul 24, 2003
 */
package AcmeStudio.remote.test.statement;

import java.util.Arrays;

/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 * 
 * Prints the value of a variable.
 */
public class ListVarsStatement extends Statement {

    public ListVarsStatement(String cmd) {
        super(cmd);
    }

    /* (non-Javadoc)
     * @see AcmeStudio.remote.test.Statement#execute(java.lang.Object)
     */
    public boolean execute(Object server) {
        boolean rv = true;

        String vars[] = Statement.listVars();
        if (vars == null || vars.length == 0) {
            // no such variable
            System.out.println("No variables defined.");
            rv = true;
        } else {
            if (cmd().equalsIgnoreCase(StatementFactory.CMD_CLEAR_VAR)) {
                // clear list of vars
                Statement.clearVars();
                System.out.println("Variables cleared!");
            } else {
                // list vars, sorted
                Arrays.sort(vars);
                System.out.println("List of variables:");
                for (int i=0; i < vars.length; i++) {
                    Object valObj = Statement.getVar(vars[i]);
                    System.out.println("  " + vars[i] + " == " + valObj + " [" + valObj.getClass() + "]");
                }
            }
        }

        return rv;
    }

    /* (non-Javadoc)
     * @see AcmeStudio.remote.test.Statement#usage()
     */
    public String usage() {
        return cmd();
    }

}
