/*
 * Created on Jul 24, 2003
 */
package AcmeStudio.remote.test.statement;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 * 
 * Prints the value of a variable.
 */
public class PauseStatement extends Statement {

    public PauseStatement(String cmd) {
        super(cmd);
    }

    /* (non-Javadoc)
     * @see AcmeStudio.remote.test.Statement#execute(java.lang.Object)
     */
    public boolean execute(Object server) {
        boolean rv = true;

        if (params().length > 0) {
            // treat first and only parameter as prompt
            String prompt = Statement.parseParam((String) params()[0]).toString();
            System.out.println("** " + prompt + " **");
        }
        // pause with prompt
        System.out.print("=> Hit <ENTER> to continue => ");
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        try {
            in.readLine();
        } catch (IOException e) {  /* ignore */ }

        return rv;
    }

    /* (non-Javadoc)
     * @see AcmeStudio.remote.test.Statement#usage()
     */
    public String usage() {
        return cmd() + " [<prompt>]";
    }

}
