/*
 * Created on Jul 24, 2003
 */
package AcmeStudio.remote.test.statement;

/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 * 
 * Sets a variable.
 */
public class SetVarStatement extends Statement {

    public SetVarStatement(String cmd) {
        super(cmd);
    }

    /* (non-Javadoc)
     * @see AcmeStudio.remote.test.Statement#execute(java.lang.Object)
     */
    public boolean execute(Object server) {
        boolean rv = true;

        if (cmd().equalsIgnoreCase(StatementFactory.CMD_UNSET_VAR)) {
            if (params().length < 1) {
                System.out.println("Usage: " + usage());
                rv = false;
            } else {
                // assume the param is var name
                String name = (String) params()[0];
                removeVar(name);
            }
        } else {
            if (params().length < 2) {
                System.out.println("Usage: " + usage());
                rv = false;
            } else {
                // assume the two params are name and value
                String name = (String) params()[0];
                String val = (String) params()[1];
                setVar(name, Statement.parseParam(val));
            }
        }

        return rv;
    }

    /* (non-Javadoc)
     * @see AcmeStudio.remote.test.Statement#usage()
     */
    public String usage() {
        if (cmd().equalsIgnoreCase(StatementFactory.CMD_UNSET_VAR)) {
            return cmd() + " <var>";
        } else {
            return cmd() + " <var> <new value>";
        }
    }

}
