package AcmeStudio.remote;

import java.io.IOException;
import java.net.URL;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;
import org.eclipse.ui.plugin.AbstractUIPlugin;

/**
 * The main _plugin class to be used in the desktop.
 */
public class AcmeStudioRemotePlugin extends AbstractUIPlugin {
	//The shared instance.
	private static AcmeStudioRemotePlugin _plugin;
	//Resource bundle.
	private ResourceBundle _resourceBundle;
	
	/**
	 * The constructor.
	 */
	public AcmeStudioRemotePlugin () {
		super();
		_plugin = this;
		try {
			_resourceBundle= ResourceBundle.getBundle("AcmeStudio.remote.acmestudioremoteplugin");
		} catch (MissingResourceException x) {
			_resourceBundle = null;
		}
	}

	/**
	 * Returns the shared instance.
	 */
	public static AcmeStudioRemotePlugin getDefault () {
		return _plugin;
	}

	/**
	 * Returns the workspace instance.
	 */
	public static IWorkspace getWorkspace () {
		return ResourcesPlugin.getWorkspace();
	}

	/**
	 * Returns the string from the _plugin's resource bundle,
	 * or 'key' if not found.
	 */
	public static String getResourceString (String key) {
		ResourceBundle bundle= AcmeStudioRemotePlugin.getDefault().getResourceBundle();
		try {
			return bundle.getString(key);
		} catch (MissingResourceException e) {
			return key;
		}
	}

    public static String getPluginPath (String filename) {
        URL url = Platform.find(getDefault().getBundle(), new Path(filename));
        String path = null;
        if (url == null) {  // non-existent _plugin??? skip it
            System.err.println("AcmeStudioRemotePlugin.getFileInPlugin(String):  Unable to find plug-in install path!");
        } else {
            try {
                url = Platform.asLocalURL(url);
            } catch (IOException e) {
                e.printStackTrace();
            }
            path = url.getPath();
        }
        return path;
    }

	/**
	 * Returns the _plugin's resource bundle,
	 */
	public ResourceBundle getResourceBundle() {
		return _resourceBundle;
	}

}
