/*
 * Created on Jul 17, 2003
 */
package AcmeStudio.remote;

import java.io.FileDescriptor;
import java.rmi.RMISecurityManager;
import java.security.Permission;

/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 * 
 * RMISecurityManager for AcmeStudio's RemoteControlServer.
 * Overrides relevant permissions to allow RemoteControlServer to work.
 */
public class RemoteControlSecurityManager extends RMISecurityManager {

    private static final boolean DUMP = false;

    /**
     * Constructs a new <code>RemoteControlSecurityManager</code>.
     */
    public RemoteControlSecurityManager() {
        super();
    }


    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkAccept(java.lang.String, int)
     */
    public void checkAccept(String host, int port) {
        // TODO DANGEROUS checkAccept POLICY
        if (DUMP) System.out.println("checkAccept host(" + host + "), port(" + port + ")");
//        super.checkAccept(host, port);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkAccess(java.lang.Thread)
     */
    public void checkAccess(Thread t) {
        // TODO DANGEROUS checkAccess POLICY
        if (DUMP) System.out.println("checkAccess thread(" + t.getName() + ")");
//        super.checkAccess(t);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkAccess(java.lang.ThreadGroup)
     */
    public void checkAccess(ThreadGroup g) {
        // TODO DANGEROUS checkAccess POLICY
        if (DUMP) System.out.println("checkAccess threadGroup(" + g.getName() + ")");
//        super.checkAccess(g);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkAwtEventQueueAccess()
     */
    public void checkAwtEventQueueAccess() {
        // TODO DANGEROUS checkAwtEventQueueAccess POLICY
        if (DUMP) System.out.println("checkAwtEventQueueAccess");
//        super.checkAwtEventQueueAccess();
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkConnect(java.lang.String, int, java.lang.Object)
     */
    public void checkConnect(String host, int port, Object context) {
        // TODO DANGEROUS checkConnect POLICY
        if (DUMP) System.out.println("checkConnect host(" + host + "), port(" + port + "), contect(" + ((context == null) ? "<null>" : context.toString()) + ")");
//        super.checkConnect(host, port, context);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkConnect(java.lang.String, int)
     */
    public void checkConnect(String host, int port) {
        // TODO DANGEROUS checkConnect POLICY
        if (DUMP) System.out.println("checkConnect host(" + host + "), port(" + port + ")");
//        super.checkConnect(host, port);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkCreateClassLoader()
     */
    public void checkCreateClassLoader() {
        // TODO DANGEROUS checkCreateClassLoader? POLICY
        if (DUMP) System.out.println("checkCreateClassLoader");
//        super.checkCreateClassLoader();
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkDelete(java.lang.String)
     */
    public void checkDelete(String file) {
        // TODO DANGEROUS checkDelete POLICY
        if (DUMP) System.out.println("checkDelete file(" + file + ")");
//        super.checkDelete(file);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkExec(java.lang.String)
     */
    public void checkExec(String cmd) {
        // TODO DANGEROUS checkExec POLICY
        if (DUMP) System.out.println("checkExec cmd(" + cmd + ")");
//        super.checkExec(cmd);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkExit(int)
     */
    public void checkExit(int status) {
        // TODO DANGEROUS checkExit POLICY
        if (DUMP) System.out.println("checkExit status(" + status + ")");
//        super.checkExit(status);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkLink(java.lang.String)
     */
    public void checkLink(String lib) {
        // TODO DANGEROUS checkLink POLICY
        if (DUMP) System.out.println("checkLink lib(" + lib + ")");
//        super.checkLink(lib);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkListen(int)
     */
    public void checkListen(int port) {
        // TODO DANGEROUS checkListen POLICY
        if (DUMP) System.out.println("checkListen port(" + port + ")");
//        super.checkListen(port);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkMemberAccess(java.lang.Class, int)
     */
    public void checkMemberAccess(Class clazz, int which) {
        // TODO DANGEROUS checkMemberAccess POLICY
        if (DUMP) System.out.println("checkMemberAccess class(" + clazz + "), which(" + which + ")");
//        super.checkMemberAccess(clazz, which);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkPackageAccess(java.lang.String)
     */
    public void checkPackageAccess(String pkg) {
        // TODO DANGEROUS checkPackageAccess POLICY
        if (DUMP) System.out.println("checkPackageAccess pkg(" + pkg + ")");
//        super.checkPackageAccess(pkg);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkPackageDefinition(java.lang.String)
     */
    public void checkPackageDefinition(String pkg) {
        // TODO DANGEROUS checkPackageDefinition POLICY
        if (DUMP) System.out.println("checkPackageDefinition pkg(" + pkg + ")");
//        super.checkPackageDefinition(pkg);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkPermission(java.security.Permission, java.lang.Object)
     */
    public void checkPermission(Permission perm, Object context) {
        // TODO DANGEROUS checkPermission-w/-context POLICY
        if (DUMP) System.out.println("checkPermission perm" + perm + ", context(" + ((context == null) ? "<null>" : context.toString()) + ")");
//        super.checkPermission(perm, context);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkPermission(java.security.Permission)
     */
    public void checkPermission(Permission perm) {
        // TODO DANGEROUS checkPermission POLICY
        if (DUMP) System.out.println("checkPermission perm" + perm);
//        super.checkPermission(perm);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkPrintJobAccess()
     */
    public void checkPrintJobAccess() {
        // TODO DANGEROUS checkPrintJobAccess POLICY
        if (DUMP) System.out.println("checkPrintJobAccess");
//        super.checkPrintJobAccess();
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkPropertiesAccess()
     */
    public void checkPropertiesAccess() {
        // TODO DANGEROUS checkPropertiesAcess POLICY
        if (DUMP) System.out.println("checkPropertiesAccess");
//        super.checkPropertiesAccess();
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkPropertyAccess(java.lang.String)
     */
    public void checkPropertyAccess(String key) {
        // TODO DANGEROUS checkPropertyAccess POLICY
        if (DUMP) System.out.println("checkPropertyAccess key(" + key + ")");
//        super.checkPropertyAccess(key);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkRead(java.io.FileDescriptor)
     */
    public void checkRead(FileDescriptor fd) {
        // TODO DANGEROUS checkRead POLICY
        if (DUMP) System.out.println("checkRead fd(" + fd + ")");
//        super.checkRead(fd);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkRead(java.lang.String, java.lang.Object)
     */
    public void checkRead(String file, Object context) {
        // TODO DANGEROUS checkRead-w/-context POLICY
        if (DUMP) System.out.println("checkRead file(" + file + "), context(" + ((context == null) ? "<null>" : context.toString()) + ")");
//        super.checkRead(file, context);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkRead(java.lang.String)
     */
    public void checkRead(String file) {
        // TODO DANGEROUS checkRead(String) POLICY
        if (DUMP) System.out.println("checkRead file(" + file + ")");
//        super.checkRead(file);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkSecurityAccess(java.lang.String)
     */
    public void checkSecurityAccess(String target) {
        // TODO DANGEROUS checkSecurityAccess POLICY
        if (DUMP) System.out.println("checkSecurityAccess target(" + target + ")");
//        super.checkSecurityAccess(target);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkSetFactory()
     */
    public void checkSetFactory() {
        // TODO DANGEROUS checkSetFactory POLICY
        if (DUMP) System.out.println("checkSetFactory");
//        super.checkSetFactory();
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkSystemClipboardAccess()
     */
    public void checkSystemClipboardAccess() {
        // TODO DANGEROUS checkSystemClipboardAccess POLICY
        if (DUMP) System.out.println("checkSystemClipboardAccess");
//        super.checkSystemClipboardAccess();
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkTopLevelWindow(java.lang.Object)
     */
    public boolean checkTopLevelWindow(Object window) {
        // TODO DANGEROUS checkTopLevelWindow POLICY
        if (DUMP) System.out.println("checkTopLevelWindow (" + window + ")");
//        return super.checkTopLevelWindow(window);
        return true;
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkWrite(java.io.FileDescriptor)
     */
    public void checkWrite(FileDescriptor fd) {
        // TODO DANGEROUS checkWrite(fd) POLICY
        if (DUMP) System.out.println("checkWrite fd(" + fd + ")");
//        super.checkWrite(fd);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#checkWrite(java.lang.String)
     */
    public void checkWrite(String file) {
        // TODO DANGEROUS checkWrite(String) POLICY
        if (DUMP) System.out.println("checkWrite file(" + file + ")");
//        super.checkWrite(file);
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#getSecurityContext()
     */
    public Object getSecurityContext() {
        return super.getSecurityContext();
    }

    /* (non-Javadoc)
     * @see java.lang.SecurityManager#getThreadGroup()
     */
    public ThreadGroup getThreadGroup() {
        return super.getThreadGroup();
    }

}
