/*
 * Created on Jul 24, 2003
 */
package AcmeStudio.remote.test.statement;

import java.util.List;

/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 * 
 * Accesses elements of a list.
 */
public class ListAccessStatement extends Statement {

    public ListAccessStatement(String cmd) {
        super(cmd);
    }

    /* (non-Javadoc)
     * @see AcmeStudio.remote.test.Statement#execute(java.lang.Object)
     */
    public boolean execute(Object server) {
        boolean rv = true;

        if (cmd().equalsIgnoreCase(StatementFactory.CMD_GET_LIST_ITEM)) {
            if (params().length < 2) {
                System.out.println("Usage: " + usage());
                return false;
            }
            // access a list
            List list = (List) Statement.parseParam((String) params()[0]);
            int i = ((Integer) Statement.parseParam((String) params()[1])).intValue();

            // store list val
            if (var() != null) {
                setVar(var(), list.get(i));
                System.out.println("-> " + var() + " = (return value) " + list.get(i));
            } else {
                System.out.println("-> Return value: " + list.get(i));
            }
        }

        return rv;
    }

    /* (non-Javadoc)
     * @see AcmeStudio.remote.test.Statement#usage()
     */
    public String usage() {
        if (cmd().equalsIgnoreCase(StatementFactory.CMD_GET_LIST_ITEM)) {
            return cmd() + " <list> <item number>";
        } else {
            return cmd();
        }
    }

}
