/*
 * Created on Jul 24, 2003
 */
package AcmeStudio.remote.test.statement;

/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 * 
 * Prints a string, number, or the value of a variable.
 */
public class PrintStatement extends Statement {

    public PrintStatement(String cmd) {
        super(cmd);
    }

    /* (non-Javadoc)
     * @see AcmeStudio.remote.test.Statement#execute(java.lang.Object)
     */
    public boolean execute(Object server) {
        boolean rv = true;

        if (params().length < 1) {
            System.out.println("Usage: " + usage());
            rv = false;
        } else {
            Object valObj = null;
            if (params()[0] instanceof String) {
                valObj = Statement.parseParam((String) params()[0]);
            } else {
                valObj = params()[0];
            }
            if (cmd().equalsIgnoreCase(StatementFactory.CMD_PRINT_LINE)) {
                System.out.println(valObj);
            } else {
                System.out.print(valObj);
            }
        }

        return rv;
    }

    /* (non-Javadoc)
     * @see AcmeStudio.remote.test.Statement#usage()
     */
    public String usage() {
        return cmd() + " <statement or var>";
    }

}
