/*
 * Created on Jul 24, 2003
 */
package AcmeStudio.remote.test.statement;

/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 * 
 * Prints the value of a variable.
 */
public class PrintVarStatement extends Statement {

    public PrintVarStatement(String cmd) {
        super(cmd);
    }

    /* (non-Javadoc)
     * @see AcmeStudio.remote.test.Statement#execute(java.lang.Object)
     */
    public boolean execute(Object server) {
        boolean rv = true;

        if (params().length < 1) {
            System.out.println("Usage: " + usage());
            rv = false;
        } else {
            // assume param refers to a variable
            Object valObj = null;
            if (params()[0] instanceof String) {
                valObj = Statement.getVar((String) params()[0]);
            } else {
                valObj = params()[0];
            }
            if (valObj == null) {
                // no such variable
                System.err.println("Var '" + params()[0] + "' does NOT exist!");
                rv = false;
            } else {
                System.out.println(params()[0] + " == " + valObj + " [" + valObj.getClass() + "]");
            }
        }

        return rv;
    }

    /* (non-Javadoc)
     * @see AcmeStudio.remote.test.Statement#usage()
     */
    public String usage() {
        return cmd() + " <var>";
    }

}
